BEGIN;
--
--
-- CREATE TABLES
--
CREATE TABLE dbinfo (
    id INTEGER PRIMARY KEY NOT NULL,
    key   VARCHAR(128) NOT NULL,
    value VARCHAR(256) 
);

INSERT INTO dbinfo (id, key, value) VALUES (1, 'version', CURRENT_TIME);
INSERT INTO dbinfo (id, key, value) VALUES (2, 'datadump', NULL);

CREATE TABLE bundeslaender_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    name VARCHAR(256) NOT NULL UNIQUE,
    kurz CHAR(2) NOT NULL UNIQUE
);

INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (-1, 'keine Angabe', '');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 0, 'Baden-Württemberg', 'BW');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 1, 'Bayern', 'BY');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 2, 'Berlin', 'BE');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 3, 'Brandenburg', 'BB');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 4, 'Bremen', 'HB');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 5, 'Hamburg', 'HH');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 6, 'Hessen', 'HE');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 7, 'Mecklenburg-Vorpommern', 'MV');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 8, 'Niedersachsen', 'NI');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 9, 'Nordrhein-Westfalen', 'NW');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (10, 'Rheinland-Pfalz', 'RP');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (11, 'Saarland', 'SL');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (12, 'Sachsen', 'SN');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (13, 'Sachsen-Anhalt', 'ST');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (14, 'Schleswig-Holstein', 'SH');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (15, 'Thüringen', 'TH');

CREATE TABLE fkz_tbl (
    id            INTEGER PRIMARY KEY NOT NULL,
    name          VARCHAR(256) NOT NULL,
    fkz           VARCHAR(256) NOT NULL UNIQUE,
    database      VARCHAR(256) NOT NULL UNIQUE,
    bundesland_id INTEGER NOT NULL REFERENCES bundeslaender_tbl(id),
    UNIQUE (fkz, database)
);

-- -- --
-- -- -- START Autogenerated CREATE part of sql statements
-- -- -- (mastert_tbl...)
-- -- --
-- -- --

--
-- CREATE TABLES
--
CREATE TABLE ort_gruppenangebot_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(67) NOT NULL
);
CREATE TABLE klassenstufe_5_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE schriftliche_kooperationsvereinbarung_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE schulform_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(48) NOT NULL
);
CREATE TABLE phase_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(18) NOT NULL
);
CREATE TABLE master_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    uuid_id CHAR(36),
    bearbeiter_id int NOT NULL,
    fkz VARCHAR(60),
    phase INTEGER DEFAULT -1,
    name_der_schule VARCHAR(60),
    schulform INTEGER DEFAULT -1,
    schulform_nennung_sonstige VARCHAR(60),
    schriftliche_kooperationsvereinbarung INTEGER DEFAULT -1,
    weitere_angaben_kooperationsvereinbarung TEXT,
    datum_begin_kooperation DATE,
    datum_ende_kooperation DATE,
    praeventionskonzept_vorhanden INTEGER DEFAULT -1,
    weitere_angaben_praeventionskonzept TEXT,
    UNIQUE (uuid_id),
    FOREIGN KEY (phase) REFERENCES phase_tbl (id),
    FOREIGN KEY (schulform) REFERENCES schulform_tbl (id),
    FOREIGN KEY (schriftliche_kooperationsvereinbarung) REFERENCES schriftliche_kooperationsvereinbarung_tbl (id),
    FOREIGN KEY (praeventionskonzept_vorhanden) REFERENCES schriftliche_kooperationsvereinbarung_tbl (id)
);
CREATE TABLE rg_gruppenangebote_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    name_gruppenangebot VARCHAR(60),
    datum_start_gruppenangebot DATE,
    datum_ende_gruppenangebot DATE,
    anzahl_teilnehmer_maennlich INTEGER,
    anzahl_teilnehmer_weiblich INTEGER,
    anzahl_teilnehmer_divers INTEGER,
    klassenstufe_5 INTEGER DEFAULT -1,
    klassenstufe_6 INTEGER DEFAULT -1,
    klassenstufe_7 INTEGER DEFAULT -1,
    klassenstufe_8 INTEGER DEFAULT -1,
    klassenstufe_9 INTEGER DEFAULT -1,
    klassenstufe_10 INTEGER DEFAULT -1,
    klassenstufe_11 INTEGER DEFAULT -1,
    klassenstufe_12 INTEGER DEFAULT -1,
    klassenstufe_13 INTEGER DEFAULT -1,
    klassenstufe_berufliche_schule INTEGER DEFAULT -1,
    inhalt_demokratiebildung INTEGER DEFAULT -1,
    inhalt_interkulturelle_kompetenz INTEGER DEFAULT -1,
    inhalt_interreligioese_kompetenz INTEGER DEFAULT -1,
    inhalt_geschlechter_reflektierte_arbeit INTEGER DEFAULT -1,
    inhalt_staerkung_der_selbstwirksamkeit INTEGER DEFAULT -1,
    inhalt_soziale_kompetenz INTEGER DEFAULT -1,
    inhalt_medienkompetenz INTEGER DEFAULT -1,
    inhalt_auseinandersetzung_menschfeindliche_ideologien INTEGER DEFAULT -1,
    inhalt_religioeses_mobbing INTEGER DEFAULT -1,
    inhalt_weitere_angaben TEXT,
    format_ag INTEGER DEFAULT -1,
    format_ausflug INTEGER DEFAULT -1,
    format_klassenfahrt INTEGER DEFAULT -1,
    format_veranstaltung INTEGER DEFAULT -1,
    format_veranstaltungsreihe INTEGER DEFAULT -1,
    format_workshop INTEGER DEFAULT -1,
    format_workshopreihe INTEGER DEFAULT -1,
    format_sonstiges INTEGER DEFAULT -1,
    methode_gruppendiskussion INTEGER DEFAULT -1,
    methode_erlebnispaedagogik INTEGER DEFAULT -1,
    methode_theaterpaedagogik INTEGER DEFAULT -1,
    methode_musikpaedagogik INTEGER DEFAULT -1,
    methode_kunstpaedagogik INTEGER DEFAULT -1,
    methode_medienpaedagogik INTEGER DEFAULT -1,
    methode_anti_gewalt_training INTEGER DEFAULT -1,
    methode_multiplikator_ausbildung INTEGER DEFAULT -1,
    methode_planspiel INTEGER DEFAULT -1,
    methode_museumspaedagogik INTEGER DEFAULT -1,
    methode_vortrag INTEGER DEFAULT -1,
    methode_weitere_angaben TEXT,
    ort_gruppenangebot INTEGER DEFAULT -1,
    format_nennung_sonstiges VARCHAR(60),
    anbieter_politische_bildung INTEGER DEFAULT -1,
    anbieter_extremismuspraevention INTEGER DEFAULT -1,
    anbieter_sonstiges INTEGER DEFAULT -1,
    anbieter_nennung_sonstiges VARCHAR(60),
    weitere_angaben_gruppenangebot TEXT,
    anzahl_individuelle_beratungen INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (klassenstufe_5) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_6) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_7) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_8) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_9) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_10) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_11) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_12) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_13) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (klassenstufe_berufliche_schule) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_demokratiebildung) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_interkulturelle_kompetenz) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_interreligioese_kompetenz) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_geschlechter_reflektierte_arbeit) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_staerkung_der_selbstwirksamkeit) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_soziale_kompetenz) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_medienkompetenz) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_auseinandersetzung_menschfeindliche_ideologien) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (inhalt_religioeses_mobbing) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_ag) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_ausflug) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_klassenfahrt) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_veranstaltung) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_veranstaltungsreihe) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_workshop) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_workshopreihe) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (format_sonstiges) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_gruppendiskussion) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_erlebnispaedagogik) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_theaterpaedagogik) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_musikpaedagogik) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_kunstpaedagogik) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_medienpaedagogik) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_anti_gewalt_training) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_multiplikator_ausbildung) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_planspiel) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_museumspaedagogik) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (methode_vortrag) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (ort_gruppenangebot) REFERENCES ort_gruppenangebot_tbl (id),
    FOREIGN KEY (anbieter_politische_bildung) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (anbieter_extremismuspraevention) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (anbieter_sonstiges) REFERENCES klassenstufe_5_tbl (id)
);

--
-- INSERT DATA
--
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (1, 'In den Räumlichkeiten der Schule');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (2, 'Außerhalb der Räumlichkeiten der Schule');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (3, 'Teilweise in und teilweise außerhalb der Räumlichkeiten der Schule');

INSERT INTO klassenstufe_5_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO klassenstufe_5_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO klassenstufe_5_tbl (id, value) VALUES (1, 'Ja');

INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (1, 'Ja');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (2, 'in Aussicht');

INSERT INTO schulform_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO schulform_tbl (id, value) VALUES (-2, 'sonstige Schule');
INSERT INTO schulform_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO schulform_tbl (id, value) VALUES (1, 'Förderschule');
INSERT INTO schulform_tbl (id, value) VALUES (2, 'Hauptschule');
INSERT INTO schulform_tbl (id, value) VALUES (3, 'Realschule');
INSERT INTO schulform_tbl (id, value) VALUES (4, 'Schularten mit drei Bildungsgängen/Gesamtschule');
INSERT INTO schulform_tbl (id, value) VALUES (5, 'Gymnasium');
INSERT INTO schulform_tbl (id, value) VALUES (6, 'Berufsschule');
INSERT INTO schulform_tbl (id, value) VALUES (7, 'Berufsvorbereitungsjahr (BVJ)');
INSERT INTO schulform_tbl (id, value) VALUES (8, 'Berufsgrundbildungsjahr (BGJ)');
INSERT INTO schulform_tbl (id, value) VALUES (9, 'Berufskolleg');
INSERT INTO schulform_tbl (id, value) VALUES (10, 'Grundschule');
INSERT INTO schulform_tbl (id, value) VALUES (11, 'Schularten mit zwei Bildungsgängen');

INSERT INTO phase_tbl (id, value) VALUES (-1, 'Unbekannt');
INSERT INTO phase_tbl (id, value) VALUES (0, 'Erfassung läuft');
INSERT INTO phase_tbl (id, value) VALUES (1, 'Erfassung beendet');

-- -- --
-- -- -- END Autogenerated CREATE part of sql statements
-- -- --
-- -- --


CREATE TABLE status_tbl (
	id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(256) NOT NULL
);

CREATE TABLE ka_status_tbl (
	id        INTEGER PRIMARY KEY NOT NULL,
	master_id INTEGER REFERENCES master_tbl(id) ON DELETE CASCADE,
	status    INTEGER DEFAULT 1 NOT NULL REFERENCES status_tbl(id),
	zugriff   timestamp,
    erstellt  timestamp,
	anonymisiert timestamp
);

INSERT INTO status_tbl (id, value) VALUES (1, 'offen');
INSERT INTO status_tbl (id, value) VALUES (2, 'geschlossen');
INSERT INTO status_tbl (id, value) VALUES (3, 'schwebend gelöscht');
INSERT INTO status_tbl (id, value) VALUES (4, 'schwebend anonymisiert');
INSERT INTO status_tbl (id, value) VALUES (5, 'anonymisiert');


CREATE TABLE tags (
    id          INTEGER PRIMARY KEY NOT NULL,
    label       VARCHAR(256) NOT NULL,
    description TEXT,
    systemtag   BOOLEAN DEFAULT TRUE
);

-- -- --
-- -- -- START Autogenerated CREATE part of sql statements for tag
-- -- --
-- -- --


-- -- --
-- -- -- END Autogenerated CREATE part of sql statements for tag
-- -- --
-- -- --

CREATE TABLE nm_tags_cases ( 
    id        INTEGER PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL REFERENCES master_tbl(id) ON DELETE CASCADE,
    tag_id    INTEGER NOT NULL REFERENCES tags(id),
    created   TIMESTAMP,
    UNIQUE (master_id, tag_id)
);

CREATE TABLE ka_logbuch_typ_tbl (
    id         SERIAL NOT NULL,
    beschreibung VARCHAR(256),
    CONSTRAINT ka_logbuch_typ_tbl_pkey PRIMARY KEY (id)
);

INSERT INTO ka_logbuch_typ_tbl (id, beschreibung) VALUES (0, 'nicht aufsuchend');
INSERT INTO ka_logbuch_typ_tbl (id, beschreibung) VALUES (1, 'aufsuchend');
INSERT INTO ka_logbuch_typ_tbl (id, beschreibung) VALUES (-1, 'Keine Angabe');

CREATE TABLE ka_logbuch_art_tbl (
    id         INTEGER NOT NULL,
    beschreibung VARCHAR(256),
    CONSTRAINT ka_logbuch_art_tbl_pkey PRIMARY KEY (id)
);

-- unmittelbare Arbeit mit dem Jugendlichen
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 0, 'Automatischer Eintrag');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 1, 'Gespräch mit dem/der Jugendlichen'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 2, 'Kompetenzfeststellung'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 3, 'Korrespondenz mit dem/der Jugendlichen (Telefonate/Schriftverkehr)'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 4, 'Begleitung des/der Jugendlichen zu externen Stellen'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 5, 'Sonstige Begleitung des Jugendlichen'); 
-- Arbeit mit Eltern/Personensorgeberechtigte
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 6, 'Gespräch mit Eltern/Personensorgeberechtigten'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 7, 'Korrespondenz mit Eltern/Personensorgeberechtigten (Telefonat/Schriftverkehr)'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 8, 'Sonstige Maßnahmen der Elternarbeit'); 
-- Arbeit mit Dritten 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 12, 'Gespräch mit beteiligten Dritten/Kooperationspartnern'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 13, 'Korrespondenz mit beteiligten Dritten/Kooperationspartnern (Telefonat/Schriftverkehr)'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 14, 'Fallkonferenz');
-- Sonstiges
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 15, 'Fahrtwege');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 16, 'Dokumentationi i-mpuls JMD');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 17, 'Teambesprechung');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 18, 'Gespräch mit Mitarbeiter/-innen der Jugendhilfe');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES (-2, 'Sonstiges');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES (-1, 'Keine Angabe');

CREATE TABLE ka_logbuch_tbl (
    id         INTEGER NOT NULL,
    master_id  int4 REFERENCES master_tbl(id)         ON DELETE CASCADE,
    datum      TIMESTAMP,
    bearbeiter VARCHAR(256),
    art        int4 REFERENCES ka_logbuch_art_tbl(id) ON DELETE SET DEFAULT,
    typ        int4 REFERENCES ka_logbuch_typ_tbl(id) ON DELETE SET DEFAULT,
    kurz_notiz VARCHAR(256),
    notiz      text,
    dauer      interval,
    CONSTRAINT ka_logbuch_tbl_pkey PRIMARY KEY (id)
);


--
-- JMD-Coaches specific definitions
--

CREATE TABLE rg_case_document_count_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    document_count BIGINT NOT NULL,

    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE
);


CREATE TABLE coaches_stellen_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    fkz VARCHAR(60),
    personen INTEGER,
    stellenanteile NUMERIC(5, 3)
);


-- -- --
-- -- -- START Autogenerated INSERT part of sql statements
-- -- -- 
-- -- --


-- -- --
-- -- --
-- -- -- END Autogenerated INSERT part of sql statements
-- -- -- 

COMMIT;
