-- Rename thema_* to inhalt_* and some related changes
-- mpuls/issue6716

-- Strategy:
--  1. add new columns with the new names
--  2. Update the new columns from teh old.
--  3. Remove the old columns

ALTER TABLE rg_gruppenangebote_tbl
  ADD inhalt_demokratiebildung INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_interkulturelle_kompetenz INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_interreligioese_kompetenz INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_geschlechter_reflektierte_arbeit INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_staerkung_der_selbstwirksamkeit INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_soziale_kompetenz INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_medienkompetenz INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_auseinandersetzung_menschfeindliche_ideologien INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_religioeses_mobbing INTEGER DEFAULT -1
      REFERENCES klassenstufe_5_tbl (id),
  ADD inhalt_weitere_angaben TEXT;
  
UPDATE rg_gruppenangebote_tbl
   SET inhalt_demokratiebildung = thema_demokratiebildung,
       inhalt_interkulturelle_kompetenz = thema_interkulturelle_kompetenz,
       inhalt_geschlechter_reflektierte_arbeit =
           thema_geschlechter_reflektierte_arbeit,
       inhalt_staerkung_der_selbstwirksamkeit =
           thema_staerkung_der_selbtswirksamkeit,
       inhalt_soziale_kompetenz = thema_soziale_kompetenz,
       inhalt_medienkompetenz = thema_medienkompetenz,
       inhalt_religioeses_mobbing = thema_religioeses_mobbing,

       inhalt_auseinandersetzung_menschfeindliche_ideologien =
           GREATEST(thema_resilienz_gegenueber_menschfeindlichen_ideologien,
                    thema_islamfeindlichkeit,
                    thema_anti_homophobie,
                    thema_antisemitismus),

       inhalt_interreligioese_kompetenz =
           GREATEST(thema_interreligioese_kompetenz,
                    thema_auseinandersetzung_mit_dem_islam),

      inhalt_weitere_angaben = thema_nennung_sonstiges;

ALTER TABLE rg_gruppenangebote_tbl
 DROP thema_interkulturelle_kompetenz,
 DROP thema_geschlechter_reflektierte_arbeit,
 DROP thema_interreligioese_kompetenz,
 DROP thema_staerkung_der_selbtswirksamkeit,
 DROP thema_soziale_kompetenz,
 DROP thema_demokratiebildung,
 DROP thema_medienkompetenz,
 DROP thema_auseinandersetzung_mit_dem_islam,
 DROP thema_antisemitismus,
 DROP thema_islamfeindlichkeit,
 DROP thema_anti_homophobie,
 DROP thema_resilienz_gegenueber_menschfeindlichen_ideologien,
 DROP thema_religioeses_mobbing,
 DROP thema_sonstiges,
 DROP thema_nennung_sonstiges;
