BEGIN;
-- issue1922: trigger actualisation of case
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1/07_rg_trigger.sql', current_timestamp);


-- ----------------------------------------------------------
-- When working with RGs, the "last modified" time of the case
-- is set as well
-- ----------------------------------------------------------
DROP TRIGGER rg_netzwerk_tbl_insert_trigger ON rg_netzwerk_tbl CASCADE;
DROP FUNCTION rg_netzwerk_tbl_insert_func();
DROP TRIGGER rg_netzwerk_tbl_delete_trigger ON rg_netzwerk_tbl CASCADE;
DROP FUNCTION rg_netzwerk_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_netzwerk_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_netzwerk_tbl_insert_trigger AFTER INSERT ON rg_netzwerk_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_netzwerk_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_netzwerk_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_netzwerk_tbl_update_trigger AFTER UPDATE ON rg_netzwerk_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_netzwerk_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_netzwerk_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_netzwerk_tbl_delete_trigger AFTER DELETE ON rg_netzwerk_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_netzwerk_tbl_delete_func();




DROP TRIGGER rg_kooperationsbezug_tbl_insert_trigger ON rg_kooperationsbezug_tbl CASCADE;
DROP FUNCTION rg_kooperationsbezug_tbl_insert_func();
DROP TRIGGER rg_kooperationsbezug_tbl_delete_trigger ON rg_kooperationsbezug_tbl CASCADE;
DROP FUNCTION rg_kooperationsbezug_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_kooperationsbezug_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kooperationsbezug_tbl_insert_trigger AFTER INSERT ON rg_kooperationsbezug_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kooperationsbezug_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_kooperationsbezug_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kooperationsbezug_tbl_update_trigger AFTER UPDATE ON rg_kooperationsbezug_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kooperationsbezug_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_kooperationsbezug_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kooperationsbezug_tbl_delete_trigger AFTER DELETE ON rg_kooperationsbezug_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kooperationsbezug_tbl_delete_func();







DROP TRIGGER rg_kjp_gruppenangebote_tbl_insert_trigger ON rg_kjp_gruppenangebote_tbl CASCADE;
DROP FUNCTION rg_kjp_gruppenangebote_tbl_insert_func();
DROP TRIGGER rg_kjp_gruppenangebote_tbl_delete_trigger ON rg_kjp_gruppenangebote_tbl CASCADE;
DROP FUNCTION rg_kjp_gruppenangebote_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_kjp_gruppenangebote_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kjp_gruppenangebote_tbl_insert_trigger AFTER INSERT ON rg_kjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kjp_gruppenangebote_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_kjp_gruppenangebote_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kjp_gruppenangebote_tbl_update_trigger AFTER UPDATE ON rg_kjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kjp_gruppenangebote_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_kjp_gruppenangebote_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kjp_gruppenangebote_tbl_delete_trigger AFTER DELETE ON rg_kjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kjp_gruppenangebote_tbl_delete_func();







DROP TRIGGER rg_nichtkjp_gruppenangebote_tbl_insert_trigger ON rg_nichtkjp_gruppenangebote_tbl CASCADE;
DROP FUNCTION rg_nichtkjp_gruppenangebote_tbl_insert_func();
DROP TRIGGER rg_nichtkjp_gruppenangebote_tbl_delete_trigger ON rg_nichtkjp_gruppenangebote_tbl CASCADE;
DROP FUNCTION rg_nichtkjp_gruppenangebote_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_nichtkjp_gruppenangebote_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_nichtkjp_gruppenangebote_tbl_insert_trigger AFTER INSERT ON rg_nichtkjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_nichtkjp_gruppenangebote_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_nichtkjp_gruppenangebote_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_nichtkjp_gruppenangebote_tbl_update_trigger AFTER UPDATE ON rg_nichtkjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_nichtkjp_gruppenangebote_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_nichtkjp_gruppenangebote_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_nichtkjp_gruppenangebote_tbl_delete_trigger AFTER DELETE ON rg_nichtkjp_gruppenangebote_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_nichtkjp_gruppenangebote_tbl_delete_func();



--
-- Finish
--
SET ROLE postgres;
--ROLLBACK;
COMMIT;
