BEGIN;

-- 1.0.2 -> 1.0.3
-- issue1802: Fügt neue Felder in die Fallakte ein

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.0.3/01-elternberatung.sql', current_timestamp);


ALTER TABLE master_tbl
  ADD COLUMN elternberatung_anzahl INTEGER DEFAULT 0,
  ADD COLUMN elternberatung_stunden INTEGER DEFAULT 0;






CREATE OR REPLACE VIEW master_tbl_view
AS SELECT 
     master_tbl.id AS id,
     master_tbl.uuid_id AS uuid_id,
     master_tbl.bearbeiter_id AS bearbeiter_id,
     master_tbl.fkz AS fkz,
     master_tbl.phase AS phase,
     master_tbl.datum_begin_zeitraum AS datum_begin_zeitraum,
     master_tbl.datum_ende_zeitraum AS datum_ende_zeitraum,
     master_tbl.raeumliche_zustaendigkeit AS raeumliche_zustaendigkeit,
     master_tbl.raeumliche_zustaendigkeit_nennung AS raeumliche_zustaendigkeit_nennung,
     master_tbl.nennung_zustaendigkeit AS nennung_zustaendigkeit,
     master_tbl.jmdstruktur AS jmdstruktur,
     master_tbl.anzahl_ha_stellenteile AS anzahl_ha_stellenteile,
     master_tbl.anzahl_ha_personen AS anzahl_ha_personen,
     master_tbl.anzahl_ha_maennlich AS anzahl_ha_maennlich,
     master_tbl.anzahl_ha_weiblich AS anzahl_ha_weiblich,
     master_tbl.anzahl_ha_migration AS anzahl_ha_migration,
     master_tbl.ha_sprachkenntnis_arabisch AS ha_sprachkenntnis_arabisch,
     master_tbl.ha_sprachkenntnis_englisch AS ha_sprachkenntnis_englisch,
     master_tbl.ha_sprachkenntnis_franzoesisch AS ha_sprachkenntnis_franzoesisch,
     master_tbl.ha_sprachkenntnis_polnisch AS ha_sprachkenntnis_polnisch,
     master_tbl.ha_sprachkenntnis_russisch AS ha_sprachkenntnis_russisch,
     master_tbl.ha_sprachkenntnis_spanisch AS ha_sprachkenntnis_spanisch,
     master_tbl.ha_sprachkenntnis_tuerkisch AS ha_sprachkenntnis_tuerkisch,
     master_tbl.ha_sprachkenntnis_sonstige AS ha_sprachkenntnis_sonstige,
     master_tbl.ha_sprachkenntnisse_sonstige_nennung AS ha_sprachkenntnisse_sonstige_nennung,
     master_tbl.verteilung_aa_begleitung_cm AS verteilung_aa_begleitung_cm,
     master_tbl.verteilung_aa_betreuung AS verteilung_aa_betreuung,
     master_tbl.verteilung_aa_gruppenangebote AS verteilung_aa_gruppenangebote,
     master_tbl.verteilung_aa_netzwerkarbeit AS verteilung_aa_netzwerkarbeit,
     master_tbl.verteilung_aa_oeffentlichkeit AS verteilung_aa_oeffentlichkeit,
     master_tbl.verteilung_aa_evaluation AS verteilung_aa_evaluation,
     master_tbl.verteilung_aa_leitung AS verteilung_aa_leitung,
     master_tbl.verteilung_aa_elternarbeit AS verteilung_aa_elternarbeit,
     master_tbl.verteilung_aa_freiwilligenarbeit AS verteilung_aa_freiwilligenarbeit,
     master_tbl.verteilung_aa_dokumentation AS verteilung_aa_dokumentation,
     master_tbl.verteilung_aa_sonstiges AS verteilung_aa_sonstiges,
     master_tbl.verteilung_aa_sonstiges_nennung AS verteilung_aa_sonstiges_nennung,
     master_tbl.anzahl_nha_stellenteile AS anzahl_nha_stellenteile,
     master_tbl.anzahl_nha_personen AS anzahl_nha_personen,
     master_tbl.anzahl_nha_maennlich AS anzahl_nha_maennlich,
     master_tbl.anzahl_nha_weiblich AS anzahl_nha_weiblich,
     master_tbl.anzahl_nha_migration AS anzahl_nha_migration,
     master_tbl.anzahl_nha_stundenunfang AS anzahl_nha_stundenunfang,
     master_tbl.anzahl_ea_personen AS anzahl_ea_personen,
     master_tbl.anzahl_ea_maennlich AS anzahl_ea_maennlich,
     master_tbl.anzahl_ea_weiblich AS anzahl_ea_weiblich,
     master_tbl.anzahl_ea_migration AS anzahl_ea_migration,
     master_tbl.anzahl_gesamt_personen AS anzahl_gesamt_personen,
     master_tbl.nennung_qualimanagement AS nennung_qualimanagement,
     master_tbl.existenz_jugendhilfekonferenz AS existenz_jugendhilfekonferenz,
     master_tbl.teilnahme_jugenhilfekonferenz AS teilnahme_jugenhilfekonferenz,
     master_tbl.existenz_jugendkonferenz AS existenz_jugendkonferenz,
     master_tbl.teilnahme_jugenkonferenz AS teilnahme_jugenkonferenz,
     master_tbl.mitarbeit_gremien AS mitarbeit_gremien,
     master_tbl.weiter_akt_art_interkulturell AS weiter_akt_art_interkulturell,
     master_tbl.weiter_akt_art_aufsuchende AS weiter_akt_art_aufsuchende,
     master_tbl.weiter_akt_art_eltern AS weiter_akt_art_eltern,
     master_tbl.weiter_akt_art_freiwilligerdienst AS weiter_akt_art_freiwilligerdienst,
     master_tbl.weiter_akt_art_sonstiges AS weiter_akt_art_sonstiges,
     master_tbl.weitere_akt_anzahl_informationsveranst AS weitere_akt_anzahl_informationsveranst,
     master_tbl.weitere_akt_anzahl_workshops AS weitere_akt_anzahl_workshops,
     master_tbl.weitere_akt_anzahl_trainings AS weitere_akt_anzahl_trainings,
     master_tbl.weitere_akt_anzahl_veroeffentlichungen AS weitere_akt_anzahl_veroeffentlichungen,
     master_tbl.weitere_akt_anzahl_referate AS weitere_akt_anzahl_referate,
     master_tbl.weitere_akt_anzahl_sonstiges AS weitere_akt_anzahl_sonstiges,
     master_tbl.elternberatung_anzahl AS elternberatung_anzahl,
     master_tbl.elternberatung_stunden AS elternberatung_stunden
FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');



-- Finish
SET ROLE postgres;

COMMIT;
