BEGIN;

-- Set role
SET ROLE :db_adm;

--
-- Modify the kompetenzfeststellung options (Issue 3444)
--

-- History
INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.3.1/07_kompetenzfeststellung.sql', current_timestamp);

CREATE TABLE kompetenzfeststellung_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(33) NOT NULL
);

INSERT INTO kompetenzfeststellung_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO kompetenzfeststellung_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO kompetenzfeststellung_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO kompetenzfeststellung_tbl (id, value) VALUES (1, 'Ja (intern/ selbst durchgeführt)');
INSERT INTO kompetenzfeststellung_tbl (id, value) VALUES (2, 'Ja (extern)');

GRANT SELECT ON kompetenzfeststellung_tbl TO GROUP :cm_group;
GRANT SELECT ON kompetenzfeststellung_tbl TO GROUP :admin_group;

ALTER TABLE master_tbl ADD FOREIGN KEY (kompetenzfeststellung) REFERENCES kompetenzfeststellung_tbl (id);
ALTER TABLE master_tbl DROP CONSTRAINT master_tbl_kompetenzfeststellung_fkey;

-- Reactivate the role
SET ROLE postgres;

COMMIT;
