# -*- coding: utf-8 -*-

import logging

from pylons import tmpl_context as c, url
from pylons.controllers.util import redirect
from mpulsweb.lib.translation import _

from mpulsweb.lib.base import BaseController, session, render, abort_unless_POST
from mpulsweb.model.news import mark_news_as_read


log = logging.getLogger(__name__)


class NewsController(BaseController):

    def hide(self, id, confirmed=0):
        """Mark news as read for the current user.
        Afterwards, the news will then not be displayed on the blackboard
        anymore for that user.
        """
        id = self._checkInt(id)
        confirmed = self._checkBool(confirmed)
        session_user = session['USER_AUTHORIZED']
        if confirmed == 1:
            abort_unless_POST()
            mark_news_as_read(id)
            redirect(url('/'))
        else:
            c.dialog_title = _(u"Mark message as read")
            c.dialog_text = \
                _(u"Do you really want to mark the message as read?\n"
                  u"It will permanently disappear from the overview.")
            c.url_yes = url(controller='news', action='hide', id=id,
                            confirmed=1)
            c.url_no = url("/")
            return render('/news/dialogs/confirm_mark_news_as_read.mako')

# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
