/*
 * (c) 2007 by Intevation GmbH
 * authors:
 * Sascha L. Teichmann <teichmann(at)intevation(dot)de>
 */
var modifiedData = false;

var MODIFICATION_WARNING = 
  "Es wurden ggf. Eingabedatenfelder verändert.\n" +
  "Wollen Sie dennoch fortfahren?"

function clearModification() {
    modifiedData = false;
}

function setModification() {
    modifiedData = true;
}

function checkModification() {
    return !modifiedData || confirm(MODIFICATION_WARNING);
    
}


// Reset the modification flag when the document is ready.
//
// Some other JS code used by mpuls might modify the form input fields
// during page-load which can lead to modifiedData being set simply by
// loading the page. Notably, this happens with the date-picker. To
// counteract this, we register our own event handler for the document's
// ready event that simply resets the modifiedData flag.
//
// For this to be effective, check.js must be loaded after any other JS
// components, like e.g. the date-picker, so that the reset is performed
// as late as possible.
$(document).ready(function() {
    clearModification();
})

// vim:set ts=4 sw=4 si et sta sts=4 fenc=uft8
