## -*- coding: utf-8 -*-
<%inherit file="/main.mako"/>
<%!  import mpulsweb.lib.helper.filters as F %>
<div>
  <div class="header">
    <h1>${_('Evaluation configuration')}</h1>
  </div>
</div>
<div>
<form action="${h.url(controller='evaluate', action='evaluateAction')}" method="POST" target="_blank">
${ h.csrf_token() }
<% 
   if c.render_options_disabled:
       disabled_options = h.literal('disabled="disabled"')
   else:
       disabled_options = ""
%>
<input type="hidden" name="id">
<table>
  <tr>
    <td class="label">${_('Name')}</td>
    <td>${c.evalconfig.get_setname()}</td>
  </tr>
  <tr>
    <td class="label">${_('Description')}</td>
    <td>${c.evalconfig.get_setdesc()}</td>
  </tr>
  <tr>
    <td class="label">${_('Phase')}</td>
    <td>
      % for n, p in enumerate(c.phases):
        <input type="checkbox" name="phase" id="phase_${n}" value="${p[0]}"
               ${disabled_options}>
          <label for="phase_${n}">
            ${p[1]}<br>
          </label>
      % endfor
    </td>
  </tr>
  <tr>
    <td class="label">${_('Start')}</td>
    <td>
      <input type="text" name="start_date" class="datefield mpuls-datepicker" ${disabled_options}>
      <form:error name="start_date" format="">
    </td>
  </tr>
  <tr>
    <td class="label">${_('End')}</td>
    <td>
      <input type="text" name="end_date" class="datefield mpuls-datepicker" ${disabled_options}>
      <form:error name="end_date" format="">
    </td>
  </tr>
  <%include file="/evaluation/evaluate_extra.mako" args="disabled_options=disabled_options"/>
  <%
     evaluation_ids = session.get("evaluation_ids")
   %>
  % if evaluation_ids:
  <tr>
    <td class="label">${_('Filter')}</td>
    <td>
      ${_("Yes")} (<a href="${h.url(controller='evaluate', action='reset_filter', id=c.eval_config_id)}">${_("Reset")}</a>)<br>
      ${(ungettext("%d case has been selected for evaluation",
                   "%d cases have been selected for evaluation",
                   len(evaluation_ids)) % len(evaluation_ids))}
      <input type="hidden" name="selected_ids">
    </td>
  </tr>
  % endif
</table>
<h2>${_('Available evaluations')}</h2>
<p>${_('Please select one or more evaluations')}</p>
<table style="table-layout:auto">
  <tr>
    <th colspan="2"><input type="checkbox" name="mpuls-toggle-all-typelist" id="toggle-typelist"><label for="toggle-typelist">${_('Select/deselect all evaluations')}</label></th>
  </tr>
  % for num, id in enumerate(c.evalconfig.get_evaluations()):
  <tr>
    <td class="${num%2 and 'hl' or ''}">
      <input type="checkbox" name="typelist" value="${id}" id="${id}">
    </td>
    <td class="${num%2 and 'hl' or ''}">
      <h3><label for="${id}">${c.evalconfig.get_name(id)}</label></h3>
      <p><label for="${id}">${c.evalconfig.get_desc(id)}</label></p>
    </td>
  </tr>
  % endfor
</table>
<table>
  <tr>
    <td colspan="3"><input type="checkbox" name="show_percent" id="show_percent"> <label for="show_percent">${_('Show percent')}</label></td> 
  </tr>
  <tr>
    <td colspan="3"><input class="button" type="submit" name="setup_evaluation" value="${_('evaluate')}"></td> 
  </tr>
</table>
</form>
</div>
