## -*- coding: utf-8 -*-
<script src="${h.url('/js/logbook.js')}"></script>
<fieldset>
  <legend>Zeitangaben</legend>
  <div class="w25">
    % if c.form_errors.get('date'):
      <label for="date" class="error_font">${_('Date:')}</label><br>
      <input type="text" class="field error_box mpuls-datepicker" name="date"
             id="date" maxlength="10" onchange="setModification();"/>
    % else:
      <label for="date">${_('Date:')}</label><br>
      <input type="text" class="field mpuls-datepicker" name="date" id="date"
             maxlength="10" onchange="setModification();"/>
    % endif
  </div>
  <div class="w75">
    % if c.form_errors.get('time'):
      <label for="date" class="error_font">${_('Time:')}</label><br>
      <input type="text" class="field error_box" name="time" id="time"
             maxlength="5" onchange="setModification();"/>
    % else:
      <label for="time">${_('Time:')}</label><br>
      <input type="text" class="field" name="time" id="time" maxlength="5"
             onchange="setModification();"/>
    % endif
  </div>
  <div class="w25">
    % if c.form_errors.get('duration'):
      <label for="duration" class="error_font">
        ${_('Duration in minutes')}:
      </label><br>
      <input type="text" class="field error_box" name="duration" id="duration"
             maxlength="4" onchange="setModification();"/>
    % else:
      <label for="duration">${_('Duration in minutes')}:</label><br>
      <input type="text" class="field" name="duration" id="duration"
             maxlength="4" onchange="setModification();"/>
    % endif
  </div>
</fieldset>
<fieldset>
  <legend>${_('entry')}</legend>
  ${_('editor')}: ${session.get('USER_AUTHORIZED').shortenedName()}
  % for num, typ in enumerate(g.mpuls_config.get('logbook', 'types')):
    <div class="w100">
      <label for="typ${num}">${typ.get('label')}:</label><br>
      <select name="${typ.get('db_field')}" id="typ${num}">
        ${h.literal("".join(h.render_logbook_typeoptions(typ)))}
      </select>
    </div>
  % endfor
  <div class="w25">
    % if c.form_errors.get('short_notice'):
      <label for="short_notice" class="error_font">
        ${_('Mention rest:')}
      </label><br>
      <input type="text" class="field error_box" name="short_notice"
             id="short_notice" maxlength="80" onchange="setModification();"/>
    % else:
      <label for="short_notice">${_('Mention rest:')}</label><br>
      <input type="text" class="field" name="short_notice" id="short_notice"
             maxlength="80" onchange="setModification();"/>
    % endif
  </div>
</fieldset>
<div>
  <label for="notice">${_('Note')}:</label><br>
  <script src="${h.url('/js/tinymce.min.js')}"></script>
  <script>
    tinymce.init({
               selector: '#notice',
               menubar: false,
               contextmenu: false, toolbar: 'undo redo | bold italic underline strikethrough | forecolor backcolor removeformat',
               statusbar: false,
               language: 'de',
               browser_spellcheck: true,
               content_css : "${h.url('/styles/tinymce_content.css')}" });
  </script>
  <textarea cols="70" rows="10" name="notice" id="notice"
            onchange="setModification();"></textarea>
</div>

% if c.edit_body_show_file_upload:
<div class="widget container w100">
  <label>${_('documents')}</label>
  <input type="file" name="file.upload" id="file" onchange="showFileSize();" multiple="multiple">
  <td class=""><span class="error"><form:error name="file"></span></td>
</div>
% endif

<div>
  <input type="hidden" name="case_id" value="">
  <input class="button" type="submit" name="save" value="Speichern">
  <input class="button" type="submit" name="save_and_back" value="Speichern und Zurück">
  <input class="button" type="submit" name="save_and_new" value="Speichern und neuen Eintrag anlegen">
</div>
