<%inherit file="/casemanagement/main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>
<%namespace file="../documents/overview.mako" import="overview_table"/>

<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li><a href="${h.url(controller='case', action='select', id=session.get('case').id, confirmed=1)}">${_('Selected case documents')}</a></li>
  <li><a href="${h.url(controller='logbook', action='index', id=session.get('case').id)}">${_('Logbook')}</a></li>
  <li><a href="#"></a>${_('Logbook entry')}</a></li>
</%def>
<div id="content_header_small">
  <div id="content_ueberschrift">
    ${_('Logbook entry')}   
  </div>
  <div id="modusfield">
    <div class="actions">
      <ul>
        % if h.hasRole(['cm']) and c.entry.is_editable_in_case(session['case']):
        <li>
          <a href="${h.url(controller='logbook', action='edit', id=c.entry.id)}">
            ${_('Edit entry')}
          </a>
        </li>
        <li>
          <a href="${h.url(controller='logbook', action='newDocument', id=c.entry.id)}">
            ${_('Add attachment')}
          </a>
        </li>
        % endif
        <li>
          <a href="${h.url(controller='logbook', action='index', id=session.get('case').id)}">${_('Back to: Logbook')}</a>
        </li>
      </ul>
    </div>
  </div>
</div>
<table>
    <tbody>
        <tr>
            <td class="label table_header_v table_width_long">Datum</td>
            <td class="table_row_v">${c.entry.getDate()} ${c.entry.getTime()}</td>
        </tr>
        <tr>
            <td class="label">${_('Editor')}</td>
            <td class="table_row_v_2">${c.entry.getEditor()}</td>
        </tr>
        <tr>
            <td class="label table_header_v">${_('Type')}</td>
            <td class="table_row_v">${c.entry.getKind()}</td>
        </tr>
        <tr>
            <td class="label">${_('Duration in minutes')}</td>
            <td class="table_row_v_2">${c.entry.getDuration('-/-')}</td>
        </tr>
        <tr>
            <td class="label table_header_v">${_('Note')}</td>
            <td class="table_row_v">${h.literal(c.entry.notiz) | F.NA}</td>
        </tr>
    </tbody>
</table>


<%def name="show_url(doc)">
${h.url(controller='logbook', action='showDocument', id=doc.id, url=doc.getName())}
</%def>

<%def name="actions(doc)">
<a href="${show_url(doc)}" target="_blank"
   ><img src="${h.url('/images/icons/open_active_22.png')}" border="0"
         alt="${_('Show')}" title="${_('Show')}" title="${_('Show')}"></a>
% if h.hasRole(['cm']) and session.get('case').is_editable_state():
  <a href="${h.url(controller='logbook', action='renameDocument', id=doc.id)}"
     ><img src="${h.url('/images/icons/edit_22.png')}" border="0"
           alt="${_('Rename')}" title="${_('Rename')}"></a>
  <a href="${h.url(controller='logbook', action='deleteDocument', id=doc.id,
                   confirmed=0)}"
     ><img src="${h.url('/images/icons/delete_active_22.png')}" border="0"
           alt="${_('Delete')}"
           title="${_('Delete')}"></a>
% endif
</%def>


<div id="content_ueberschrift">
  ${_('Document overview')}
</div>

${overview_table(show_url, actions)}
