## -*- coding: utf-8 -*-
<%inherit file="base.mako" />

<%def name="buildStatusBar()">
  <div id="statusbar">
    ${_('Login as')}:
    % if g.mpuls_config.is_enabled('module', 'administration'):
        <a href="${h.url(controller='usersettings', action='showSettings')}"
           title="${_('My Account')}"
           id="userSettings"
           onclick="return checkModification();">
    % endif
    % if h.getLogin() != 'adm':
        <strong>${h.getUserFullname()}</strong> (${h.getRole()})
    % if g.mpuls_config.is_enabled('module', 'administration'):
          </a>
    % endif
    % else:
        <strong>adm</strong> (initiale Anmeldekennung)
    % if g.mpuls_config.is_enabled('module', 'administration'):
          </a>
        % endif
    % endif
  </div>
</%def>

<%def name="buildStartMenu()">
  <div id="startmenu">
    <ul>
      <li>
        <a href="${h.url('/')}"
           id="blackBoard"
           onclick="return checkModification();">
          ${_('Black board')}
        </a>
      </li>
      % if g.mpuls_config.is_enabled('module', 'administration'):
      <li>
        <a href="${h.url(controller='usersettings', action='showSettings')}"
           id="usetSettingsShowSettings"
           onclick="return checkModification();">
          ${_('My Account')}
        </a>
      </li>
      % endif
      <li>
          <a href="${h.url(controller='help', action='index')}"
             id="help"
           onclick="return checkModification();">
           ${_('Help')}</a>
      </li>
      <li>
        <a href="${h.url(controller='auth', action='logout')}"
           id="logout"
           onclick="return checkModification();">
          ${_('Logout')}</a>
      </li>
    </ul>
  </div>
</%def>

<%def name="buildNavipath()">
  <li><a href="${h.url('/')}"
         id="breadCrumbRoot"
         onclick="return checkModification();">${_('%s Start') % h.get_app_title()}</a></li>
</%def>

<%def name="buildInfofield()">
</%def>

<%def name="buildPrivacyfield()">
</%def>

<%def name="buildIco()">
  <span class="menuico"> &gt;&gt;</span>
</%def>

<%def name="buildNavigation()">
  % if (h.getLogin() != 'adm'):
    % if h.hasRole(['cm', 'admin']):
      <div class="menu">
        <div class="actions">
          <h1>${_('%s Start') % h.get_app_title()}</h1>
          <ul>
            <li>
              <a href="${h.url('/')}" id="blackBoardSideNavigation">
                ${_('Black board')}
              </a>
            </li>
            ## APPOINTMENTS 
            % if g.mpuls_config.is_enabled('module', 'appointments'):
              <li>
                <a href="${h.url(controller='appointment',
                                     action='overview')}"
                   id="appointmentOverview">
                  ${_('Events')}
                </a>
              </li>
            % endif
            ## DOCUMENTS
            % if g.mpuls_config.is_enabled('module', 'documents'):
              <li>
                <a href="${h.url(controller='document', 
                                     action='globalOverview')}"
                   id="documentGlobalOverview">
                  ${_('Documents')}
                </a>
              </li>
              % if h.hasRole(['cm']):
                <li>
                  <a href="${h.url(controller='userdocument',
                                   action='overview')}"
                     id="documentUserOverview">
                    ${_('My Documents')}
                  </a>
                </li>
              % endif
            % endif
          </ul>
        </div>
      </div>
    % endif
    <div class="menu">
      <div class="actions">
        % if g.mpuls_config.is_enabled('module', 'casemanagement'):
          <h1>${_('Case Management')}</h1>
          <ul>
            <li>
              <a href="${h.url(controller='case_overview',
                                   action='overview')}"
                 id="caseoverviewOverview">
                ${_('Case documents	')}
              </a>
            </li>
            % if h.hasRole(['cm']):
              % if g.mpuls_config.is_enabled('case-module', 'create'):
              <li>
                <a href="${h.url(controller='case', action='new')}"
                   id="caseNew">
                  ${_('New case document')}
                </a> 
              </li>
              % endif
              % if g.mpuls_config.is_enabled('case-module', 'import'):
                <li>
                  <a href="${h.url(controller='case', action='importCase')}"
                     id="caseImportCase">
                    ${_('Import case document')}
                  </a>
                </li>
              % endif
            % endif
          </ul>
        % endif
      </div>
    </div>
    <%include file="switch_to_other_datasets.mako" />
    % if g.mpuls_config.is_enabled('module', 'agency-overview'):
      <div class="menu">
        <div class="actions">
          <h1>${_('Overview')}</h1>
            <ul>
              <li>
                <a href="${h.url(controller='evaluation_overview', action='index')}"
                   id="evaluationOverviewIndex">
                  ${_('Agency')}
                </a>
              </li>
            </ul>
        </div>
      </div>
    % endif
    % if g.mpuls_config.is_enabled('module', 'evaluation'):
      <div class="menu">
        <div class="actions">
          <h1>${_('Evaluations')}</h1>
          ${self.buildEvaluations()}
        </div>
      </div>
    % endif
  % endif
  % if h.hasRole(['admin']) and g.mpuls_config.is_enabled('module', 'administration'):
    <div class="menu">
      <div class="actions">
        <h1>${_('Administration')}</h1>
        <ul>
          <li>
            <a href="${h.url(controller='administration',
                                 action='overviewUser')}"
               id="administrationOverviewUser"> 
              ${_('User')}
            </a>
          </li>
	  % if (h.getLogin() != 'adm'):
          % if not g.mpuls_config.is_enabled('module', 'agency-overview'):
            <li>
              <a href="${h.url(controller='administration',
                                   action='overviewUserGroups')}"
                 id="administrationOverviewUserGroups">
                ${_('Usergroup')}
              </a>
            </li>
            <li>
              <a href="${h.url(controller='settings', action='index')}"
                 id="settings">
                ${_('Settings')}
              </a>
            </li>
          % endif
	  % endif
        </ul>
      </div>
    </div>
  % endif
</%def>

<%def name="buildEvaluations()">
  <ul>
    % for eval in g.mpuls_config.get('evaluations', 'enabled'):
      % if h.can_use_evaluation(eval):
      <li>
        <a href="${h.url(controller='evaluate', action='evaluate',
                         id=eval.get('id'))}"
           id="evaluateEvaluate">${eval.get('name')}</a>
      </li>
      % endif
    % endfor
  </ul>
</%def>

<%def name="buildFormErrors(labels=None)">
  <% formular_labels = labels or {} %>
  % if len(c.form_errors) > 0:
    <div class="form_errors">
      <h1><a name="error_list">${_('Wrong formular input')}</a></h1>
      <ul>
        % for key, value in c.form_errors.iteritems():
          <li>${_(formular_labels.get(key, '%s' % key))}: ${value}</li>
        % endfor
      </ul>
    </div>
  % endif
</%def>

<%def name="buildFooter()">
  <div id="footer">
    <div id="version_str">
    <a href="${h.url(controller='info', action='index')}"
           onclick="return checkModification();"
           id="info">
          ${_('Info')}</a>
      | ${g.mpuls_config.get_app_name()}
      | ${g.mpuls_config.get_releasedate()}
      | ${g.mpuls_config.get_app_version()}
    </div>
  </div>
</%def>

<%def name="buildContentHeader()">
  ${self.buildUeberschrift()}
  ${self.buildModusfield()}
</%def>

<%def name="buildUeberschrift()">
</%def>

<%def name="buildModusfield()">
</%def>

<span class="skiplink">
  <a href="#startmenu" title="${_('Go to main menu directly')}" 
     tabindex="1">
   ${_('Go to main menu')} 
  </a>
</span>
<span class="skiplink">
  <a href="#navigation" title="${_('Go to domain menu directly')}" 
     tabindex="1">
  ${_('Go to domain menu')}
  </a>
</span>
<span class="skiplink">
  <a href="#content" title="${_('Go to content directly')}" tabindex="2">
    ${_('Go to content')}
  </a>
</span>
<div class="mpuls-block">
  <div class="mpuls-sidebar" id="logo">
    <a href="${h.url('/')}"
       onclick="return checkModification();">
      <img src="${h.url('/images/logos/logo_ka_75.png')}" 
           alt="${_('Logo agency')}" border="0">
    </a>
  </div>
  <div class="mpuls-content">
    <div class="mpuls-inner-content">
        ${self.buildStartMenu()}
        ${self.buildStatusBar()}
        <div id="navipath">
          <ul>
            ${self.buildNavipath()}
          </ul>
        </div>
    </div>
  </div>
</div>
<hr>
<div class="mpuls-block" id="main">
  <div class="mpuls-sidebar">
    <div>
      % if h.hasRole(['cm']):
        ${self.buildPrivacyfield()}
      % endif
      ${next.buildNavigation()}
    </div>
  </div>
  <div class="mpuls-content">
    <div class="mpuls-inner-content">
      <div id="content">
        <div id="status_str_nofloat">
        % if c.status_msg:
          <span class="redcolor">${c.status_msg}</span>
        % else:
          <strong>${_('Notice')}:</strong> 
          ${_('This session will be automatically terminated at %s. Please make sure you have saved you entries!') % h.get_logouttime() }
        % endif
        </div>
      ${self.buildContentHeader()}
      ${self.body()}
      </div>
    </div>
  </div>
</div>
${self.buildFooter()}
