#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys
import psycopg2

UPDATE_MODELPLACE_WITH_UUID = """\
UPDATE rg_einrichtung_tbl SET model_place=%s, measure_name=%s WHERE uuid_id=%s""" 
SQL_GET_MODELPLACE = """\
SELECT model_place FROM rg_einrichtung_tbl
WHERE uuid_id=%s"""

def update_air_dbs(dblist, port, uuid_dbname_dict):
    #print "update air dbs using dbs: %s" % ", ".join(dblist)
    log = []
    for db in dblist:
        con = None
        try:
            con = psycopg2.connect(database="ka_" +db+"_db", port=port)
            cur = con.cursor()
            for uuid in uuid_dbname_dict:
                old_model_place = get_model_place(cur, uuid)
                cur.execute(UPDATE_MODELPLACE_WITH_UUID, 
                            (uuid_dbname_dict[uuid], uuid_dbname_dict[uuid], uuid))
                new_model_place = get_model_place(cur, uuid)
		if new_model_place:
		    log.append("db: %s, uuid: %s, %s -> %s" % (db, uuid, old_model_place, new_model_place))
                # print ("uuid: %s, old model place: %s, new model place: %s" %
                #        (uuid, old_model_place, new_model_place))
            con.commit()        
        except psycopg2.DatabaseError, e:
            print "Error: %s" % e
        finally:
            if con:
                con.close()
    print "Updated %s cases" % len(log)
    print "\n".join(log)

def get_model_place(cur, uuid):
    model_place= ""
    cur.execute(SQL_GET_MODELPLACE, (uuid,))
    for row in cur.fetchall():
        if row[0]:
            model_place = row[0]
    return model_place

def read_db_lists(filename):
    dbs = []
    f1 = open(filename)
    for line in f1:
        if line.strip():
            dbs.append(line.strip())
    f1.close()
    return dbs

def main():
    if not len(sys.argv) == 4:
        print "updatemeta.py <air dbs> <air port> <mapping>"
        print "Not three options -> exit"
        return
    
    mapping = open(sys.argv[3])
    uuid_dbname_dict = eval(mapping.read())
    mapping.close()
    # Read the air dbs from argv 2, in the file should be one line per db name.
    # Then update the air dbs and generate logging.
    air_dbs = read_db_lists(sys.argv[1])
    print "Setting modelplace in meta database..."
    update_air_dbs(air_dbs,sys.argv[2], uuid_dbname_dict)

main()
