#!/bin/sh
set -e
set -x

TYPE=$1
PORT=${3-5437}
DATE=${2:-`date +%Y-%m-%d`}
DB=ka_stservicestelleauswertung102_db

TRANSFERDIR=/home/mpuls/transfer-struktur
DATADIR=${TRANSFERDIR}/data/bund

ARCHIVDIR=/var/www/${TYPE}/archive 

IMPORTCOMMAND=$TRANSFERDIR/import-sqlite.py
IMPORTFILE=${TYPE}-${DATE}.db

echo =======================
echo START `date +'%Y-%m-%d %H:%M:%S'` on ${TRANSFERDIR}
echo ======================

# 1. Create a database

# 2. Import data

# 3. Copy data to archive

# Stop Webserver
#/etc/init.d/apache2 stop
## Copying data to archive 
echo "Copy to archive..."
#cp ${DATADIR}/${IMPORTFILE} ${ARCHIVDIR}
cd ${DATADIR}

bunzip2 -c ${IMPORTFILE}.bz2 > sb.${IMPORTFILE}

# Delete all cases
#echo "Delete old data..."
sudo -u postgres psql -p ${PORT} ${DB} -c "TRUNCATE master_tbl CASCADE"
#
echo "Import new data..."
sudo -u postgres ${IMPORTCOMMAND} -i ${DATADIR}/sb.${IMPORTFILE} -o $DB -p ${PORT} 

# Clean up
rm sb.${IMPORTFILE}

echo =======================
echo END `date +'%Y-%m-%d %H:%M:%S'`
echo ======================
